/*
 *
 *     This file is part of the Squashtest platform.
 *     Copyright (C) 2017 Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.plugin.rest.validators;

import org.springframework.stereotype.Component;
import org.springframework.validation.BeanPropertyBindingResult;
import org.springframework.validation.BindException;
import org.springframework.validation.BindingResult;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;
import org.squashtest.tm.domain.customfield.BindableEntity;
import org.squashtest.tm.domain.testcase.Parameter;
import org.squashtest.tm.plugin.rest.controller.helper.ErrorHandlerHelper;
import org.squashtest.tm.plugin.rest.jackson.model.TestCaseDto;
import org.squashtest.tm.plugin.rest.jackson.model.TestStepDto;
import org.squashtest.tm.plugin.rest.validators.helper.TestCaseDtoValidationHelper;

import javax.inject.Inject;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import static org.squashtest.tm.plugin.rest.jackson.model.RestType.REQUIREMENT;
import static org.squashtest.tm.plugin.rest.jackson.model.RestType.TEST_CASE;

@Component
public class TestCasePostValidator implements Validator {
    @Inject
    private TestCaseDtoValidationHelper testCaseDtoValidationHelper;
    @Inject
    private ParameterValidator parameterValidator;

    @Inject
    private TestStepValidator testStepValidator;

    @Override
    public boolean supports(Class<?> clazz) {
        return TestCaseDto.class.equals(clazz);
    }

    @Override
    public void validate(Object target, final Errors errors) {
        TestCaseDto testCaseDto = (TestCaseDto) target;

        if (testCaseDto.getId() != null) {
            errors.rejectValue("id", "generated value", "This attribute is generated by database and should not be provided. If you want to update an existing test case, please do a patch request to the test case id. ");
        }

        ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "required", "This attribute can't be empty");
        testCaseDtoValidationHelper.checkParent(errors, testCaseDto, TEST_CASE);

        if (errors.hasErrors()) { //at this stage if we have an error, especially on parent we don't want nasty null pointer or other unpredictable exception, so return...
            return;
        }

        testCaseDtoValidationHelper.checkInvalidAttributeForEachTestCaseType(errors, testCaseDto);
        testCaseDtoValidationHelper.assignProject(testCaseDto);
        testCaseDtoValidationHelper.assignInfoList(errors, testCaseDto);
        testCaseDtoValidationHelper.checkCufs(errors, testCaseDto, BindableEntity.TEST_CASE);
        testCaseDtoValidationHelper.checkAutomationAttributes(errors, testCaseDto);
    }

    public void validateRequirements(long testCaseId, List<Long> requirementIds, String errorMessage) throws BindException {
        List<Errors> errors = new ArrayList<>();
        TestCaseDto testCaseDto = new TestCaseDto();
        BindingResult validationBean = new BeanPropertyBindingResult(testCaseDto, errorMessage);
        testCaseDtoValidationHelper.checkEntityExist(validationBean, TEST_CASE, testCaseId);
        for (Long id : requirementIds) {
            testCaseDtoValidationHelper.checkEntityExist(validationBean, REQUIREMENT, id);
        }
        if (validationBean.hasErrors()) {
            errors.add(validationBean);
        }
        ErrorHandlerHelper.throwIfError(testCaseDto, errors, errorMessage);
    }


    public void validateParameters(TestCaseDto testCaseDto, List<Errors> errors, BindingResult validation) {
        Set<Parameter> parameters = testCaseDto.getParameters();
        if (parameters == null) {
            return;
        }
        for (Parameter parameter : parameters) {
            parameterValidator.validate(parameter, validation);
            if (validation.hasErrors()) {
                errors.add(validation);
            }
        }
    }

    public void validateTestSteps(TestCaseDto testCaseDto, List<Errors> errors, BindingResult validation) {
        List<TestStepDto> stepDtos = testCaseDto.getSteps();
        Long projectId = testCaseDto.getProject().getId();
        if (stepDtos == null) {
            return;
        }
        for (TestStepDto stepDto : stepDtos) {
            //must have set project before in test case validator
            stepDto.setProjectId(projectId);
            testStepValidator.validate(stepDto, validation);
            if (validation.hasErrors()) {
                errors.add(validation);
            }
        }
    }

}
